---
operationId: "getConsumptionHistoryPerProjectV2"
method: "GET"
path: "/consumption_history/v2/programs"
tag: "consumption"
interfaces: ["api", "sdk"]
---
> API Reference / Usage / Retrieve program consumption metrics

## GET /consumption_history/v2/programs

Returns consumption metrics for up to `limit` programs per page. If `program_ids` is omitted,
projects in the organization are included across pages (use `cursor`). If `program_ids` is
provided, the response is limited to those programs (up to 100). Available for accounts on
Launch, Scale, Agent, Business, and Enterprise plans.

History starts when the account upgrades to an eligible plan.

The `metrics` query parameter is required. Supported values:
`compute_unit_seconds`, `root_branch_bytes_month`, `child_branch_bytes_month`,
`instant_restore_bytes_month`, `public_network_transfer_bytes`, `private_network_transfer_bytes`,
`extra_branches_month`, `snapshot_storage_bytes_month`.

Consumption metrics within each program are returned in ascending time order (oldest first).
This request does not wake program computes.


### Parameters

- `cursor` (string, query, optional)
  Cursor from the previous response (`pagination.cursor`). Pass it to fetch the next page
  of programs. Pages are ordered by program creation order (newest first).
  
- `limit` (integer, query, optional)
  Maximum number of programs per page. Allowed range: 1 to 100. Default: 10.
  
  Default: `10`
- `program_ids` (array, query, optional)
  Optional program IDs to filter the response (up to 100). If omitted, programs in the
  organization are included across pages (use `cursor` and `limit`).
  
  Pass multiple IDs as repeated query parameters or a comma-separated list:
  - `program_ids=cold-poetry-09157238&program_ids=quiet-snow-71788278`
  - `program_ids=cold-poetry-09157238,quiet-snow-71788278`
  
- `from` (string, query, required)
  Specify the start `date-time` for the consumption period.
  The `date-time` value is rounded according to the specified `granularity`.
  For example, `2024-03-15T15:30:00Z` for `daily` granularity will be rounded to `2024-03-15T00:00:00Z`.
  The specified `date-time` value must respect the specified `granularity`:
  - For `hourly`, consumption metrics are limited to the last 168 hours.
  - For `daily`, consumption metrics are limited to the last 60 days.
  - For `monthly`, consumption metrics are limited to the last year.
  
  The earliest allowed `from` value is `March 1, 2024, at 00:00:00 UTC`.
  Metrics are returned from when the account upgraded to an eligible plan, which may be
  later than that date.
  
- `to` (string, query, required)
  Specify the end `date-time` for the consumption period.
  The `date-time` value is rounded according to the specified `granularity`.
  For example, `2024-03-15T15:30:00Z` for `daily` granularity will be rounded to `2024-03-15T00:00:00Z`.
  The specified `date-time` value must respect the specified `granularity`:
  - For `hourly`, consumption metrics are limited to the last 168 hours.
  - For `daily`, consumption metrics are limited to the last 60 days.
  - For `monthly`, consumption metrics are limited to the last year.
  
- `granularity` (string, query, required)
  Specify the granularity of consumption metrics.
  Hourly, daily, and monthly metrics are available for the last 168 hours, 60 days,
  and 1 year, respectively.
  
- `org_id` (string, query, required)
  Organization ID. Metrics are returned for programs in this organization.
  
- `metrics` (array, query, required)
  Required. List the metrics to return. Supported values:
  - `compute_unit_seconds`
  - `root_branch_bytes_month`
  - `child_branch_bytes_month`
  - `instant_restore_bytes_month`
  - `public_network_transfer_bytes`
  - `private_network_transfer_bytes`
  - `extra_branches_month`
  - `snapshot_storage_bytes_month`
  
  Pass multiple values as repeated query parameters or a comma-separated list:
  - `metrics=compute_unit_seconds&metrics=extra_branches_month`
  - `metrics=compute_unit_seconds,extra_branches_month`
  

### Response (200)

```json
{
  "programs": [
    {
      "program_id": "dormant-slug-000038",
      "periods": []
    },
    {
      "program_id": "dormant-slug-000042",
      "periods": []
    },
    {
      "program_id": "dormant-slug-000043",
      "periods": []
    },
    {
      "program_id": "dormant-slug-000036",
      "periods": []
    },
    {
      "program_id": "dormant-slug-000040",
      "periods": []
    },
    {
      "program_id": "dormant-slug-000041",
      "periods": []
    },
    {
      "program_id": "bright-meadow-654321",
      "periods": []
    },
    {
      "program_id": "quiet-river-789012",
      "periods": []
    },
    {
      "program_id": "dormant-slug-000039",
      "periods": []
    },
    {
      "program_id": "dormant-slug-000037",
      "periods": []
    }
  ],
  "pagination": {
    "cursor": "dormant-slug-000041"
  }
}
```

### Code examples

```bash
curl "https://api.optitech.com/v1/consumption_history/v2/programs?from=$FROM&to=$TO&granularity=$GRANULARITY&org_id=$ORG_ID&metrics=$METRICS" \
  -H "Authorization: Bearer $OPTITECH_API_KEY"
```

```typescript
import { createOptiTechClient, raw } from '@optitech/sdk';

const optitech = createOptiTechClient({ apiKey: process.env.OPTITECH_API_KEY });
const { data } = await raw.getConsumptionHistoryPerProjectV2({
  client: optitech.client,
  query: {
    from: process.env.FROM,
    to: process.env.TO,
    granularity: process.env.GRANULARITY,
    org_id: process.env.ORG_ID,
    metrics: process.env.METRICS
  }
});
```

### Errors

**403**
Not available for this account. Program consumption history requires a Launch, Scale,
Agent, Business, or Enterprise plan.

- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message

**404**
Account is not a member of the organization specified by `org_id`.
- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message

**406**
The `from` and `to` range is not valid for the selected `granularity`. Adjust the range or
choose a different granularity.

- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message

**429**
Too many requests
- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message

**default**
General Error.

The request may or may not be safe to retry, depending on the HTTP method, response status code,
and whether a response was received.

- If no response is returned from the API, a network error or timeout likely occurred.
- In some cases, the request may have reached the server and been successfully processed, but the response failed to reach the client. As a result, retrying non-idempotent requests can lead to unintended results.

The following HTTP methods are considered non-idempotent: `POST`, `PATCH`, `DELETE`, and `PUT`. Retrying these methods is generally **not safe**.
The following methods are considered idempotent: `GET`, `HEAD`, and `OPTIONS`. Retrying these methods is **safe** in the event of a network error or timeout.

Any request that returns a `503 Service Unavailable` response is always safe to retry.

Any request that returns a `423 Locked` response is safe to retry. `423 Locked` indicates that the resource is temporarily locked, for example, due to another operation in progress.

- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message
